
#include "sis.h"
#include "th_int.h"

static int majcheck_usage ARGS((void));

int com_majcheck(network_t **network, int argc, char **argv)
{
  int c, i, non_count;
  array_t *node_vec;
  node_t *node;
  st_table *table_1, *table_2, *table_3;  

  
  util_getopt_reset();

   while ((c = util_getopt(argc, argv, "h")) != EOF) {
    switch(c) {
    case 'h':
      return majcheck_usage();
    default:
      return majcheck_usage();
    }
  }

   /* create the hash tables */
table_1 = maj_table_1();
table_2 = maj_table_2();
table_3 = maj_table_3();

  node_vec = network_dfs(*network);
  non_count = 0;
  for (i = 0; i < array_n(node_vec); i++) {
    node = array_fetch(node_t *,node_vec,i);
    if ((node_type(node) != PRIMARY_OUTPUT) && (node_type(node) != PRIMARY_INPUT)) {
     if (node_equal(node, node_constant(0)) || node_equal(node, node_constant(1))) {
       ;
     }
     else if (node_num_fanin(node) == 1)
       ;
     else if (node_num_fanin(node) == 2) {
       if ((node_function(node) != NODE_AND) && (node_function(node) != NODE_OR)) {
	 node_print(sisout, node);
	 non_count++;
       }
     }
     else if (node_num_fanin(node) == 3) {
       if (check_is_majority(node->F, table_1, table_2, table_3) == 0) {
	 node_print(sisout, node);
	 non_count++;
       }
     }
     else {
       node_print(sisout, node);
       non_count++;
     }
    }
    
  }
  
  if (non_count > 0) {
    printf("Failed check\nTotal non-majority node: %d\n", non_count);
    return 1;
  }

  printf("Passed check\n"); 
  return 0;
}


/*****************************************/
/* usage information of majcheck command */
/*****************************************/
static int majcheck_usage(void)
{
  fprintf(siserr, "usage: majsyn [-h]\n");
  fprintf(siserr, "    check if the network is a majority network.\n");
  return 0;
}
