/*=========================================================================*
 *	File    :	thconv.c
 *
 *	Author  :	Pallav Gupta
 *	Created :	Mon Sep 15 13:26:58 2003
 *
 * This source code can be redistributed under the GNU Free Public Licence.
 *=========================================================================*/

/* $Id: thconv.c,v 1.5 2004/06/21 18:49:09 sis Exp $ */

#include "sis.h"
#include "th_int.h"


/* perform one-to-one mapping by decomposing the network using AND/OR/INV gates only */
/*  and converting each gate into a threshold gate */
int th_mapoto(network_t *network, int alim, int olim, thsyn_options_t *opt)
{
  lsGen gen;
  node_t *n;
  node_function_t nfunc;
 
  /*  technology decomposition and removal of hanging nodes */
  decomp_tech_network(network, alim, olim);
  network_sweep(network);
  
  //rui 
  /* write the linear problem AMPL model file and command files */
  thsyn_write_ampl_model(opt);
  thsyn_write_ampl_commands(opt);
  //rui

  foreach_node(network, gen, n) {
    nfunc = node_function(n);

    if (nfunc == NODE_AND || nfunc == NODE_OR || nfunc == NODE_INV ||
	nfunc == NODE_BUF || nfunc == NODE_PI || nfunc == NODE_PO ||
	nfunc == NODE_0 || nfunc == NODE_1)
      thnode_assign_weights(n, opt);
    else 
      fail("bad function type");
  }

  /*  this is now a valid threshod network */
  network->threshold = 1;
  return TH_SUCCESS;
}
